100 REMark Westward-Ho  David H.Ahl, 1986
110 REMark ported to QL by David Denham, June 2014
120 :
130 ox%       = 0 : REMark x-origin preset
140 oy%       = 0 : REMark y-origin preset
150 sound_on% = 0 : REMark Fanfare toggle
160 :
170 INITIALISE_DISPLAY : REMark QL specific
180 CLS
190 LOCATE 9, 32 : STRIP 2 : CSIZE 0,1
200 PRINT "  Westward Ho! 1847  " : STRIP 0 : CSIZE 0,0
210 PRINT\\TO 31; "(c)  David H. Ahl, 1986"
220 PRINT\TO 21; "(ported to Sinclair QL by David Denham, 2014)" : LOCATE 23, 23
230 :
240 REMark Initialization
250 _MP = 0 : REMark mileage flag for South Pass
260 RESTORE
270 DIM DA$(20,12), EP(20), MP(15), PL$(15,50)
280 GO SUB 3590 : GO SUB 3720 : GO SUB 3900 : REMark Put data in variables
290 INPUT "Press ENTER when you're ready to go > ";Z$
300 CLS
310 :
320 GO SUB 620 : REMark Display the scenario
330 GO SUB 820 : REMark Make initial purchases
340 GO SUB 1050 : REMark How good a shot are you?
350 PRINT : PRINT "Your trip is about to begin..." : PRINT : Fanfare
360 :
370 REMark Main program
380 IF M > 2039 THEN GO TO 3330 : REMark Reached the final segment?
390 J = J + 1 : REMark Iterate through 2-week trip segments
400 IF J > 20 THEN GO TO 3220 : REMark On the trail too long?
410 PRINT : PRINT "Monday, ";DA$(J);", 1847. You are ";
420 FOR I = 1 TO 15 : IF M > MP(I) THEN PRINT PL$(I): EXIT I
430 IF F < 6 THEN PRINT "You're low on food. Better buy some or go hunting soon."
440 IF KS <> 1 AND KH <> 1 THEN GO TO 490 : REMark Any sickness or injuries?
450 T = T - 10 : IF T < 0 THEN GO TO 3150 : ELSE PRINT "Doctor charged $10 for his services";
460 PRINT "to treat your "; : IF KS = 1 THEN PRINT "illness." : ELSE PRINT "injuries."
470 KS = 0 : KH = 0 : REMark Set illness and injury flags to normal
480 M = INT(M) : MA = M : REMark Update cumulative mileage
490 IF _MP = 1 THEN PRINT "Total mileage to date is 950." : _MP = 0 : GO TO 520
500 PRINT "Total mileage to date is "; INT(M + .5)
510 M = (M + 200 + (A - 110) / 2.5) + RND(0 TO 9) : REMark Calculate how far we travel in 2 weeks
520 PRINT "Here's what you now have (no. of bullets, $ worth of other items) :"
530 GO SUB 3490 : REMark Print inventory
540 GO SUB 1130 : REMark Stop at fort, hunt, or push on routine
550 GO SUB 1440 : REMark Eating routine
560 GO SUB 1520 : PRINT : REMark Riders - attack routine
570 GO SUB 1930 : PRINT : REMark Hazards - and - events routine
580 GO SUB 2780 : REMark Mountains routine
590 GO SUB 3950 : REMark short pause between segments
600 GO TO  380  : REMark End of the 2-week trip segment
610 :
620 REMark Subroutine to print initial scenario
630 LOCATE 0,32 : STRIP 2
640 PRINT "  Westward Ho! 1847  " : STRIP 0 : PRINT
650 PRINT "Your journey over the Oregon Trail takes place in 1847. Starting in Independence,"
660 PRINT "Missouri, you plan to take your family of five over 2040 tough miles to Oregon City."
670 PRINT\"Having saved $420 for the trip, you bought a wagon for $70 and now have to purchase"
680 PRINT "the following items :" : PRINT
690 PRINT\"* Oxen (spending more will buy you a larger and better team which will be faster so"
700 PRINT "  you'll be on the trail for less time)"
710 PRINT "* Food (you'll need ample food to keep up your strength and health)"
720 PRINT "* Ammunition ($1 buys a belt of 50 bullets. You'll need ammo for hunting and for"
730 PRINT "  hunting and for fighting off attacks by bandits and animals)"
740 PRINT "* Clothing (you'll need warm clothes, especially when you hit the snow and freezing"
750 PRINT "  weather in the mountains)"
760 PRINT "* Other supplies (includes medicine, first-aid supplies, tools, and wagon parts for"
770 PRINT "  unexpected emergencies)" : PRINT
780 PRINT\"You can spend all your money at the start or save some to spend at forts along the"
790 PRINT "However, items cost more at the forts. You can also hunt for food if you run low."
800 PRINT : RETurn
810 :
820 REMark Subroutine to get initial purchases of player
830 PRINT : INPUT "How much do you want to pay for a team of oxen? $";A : A = INT(A)
840 IF A < 100 THEN PRINT "No one in town has a team that cheap." : GO TO 830
850 IF A < 151 THEN GO TO 890
860 PRINT "You choose an honest dealer who tells you that $";A;"is too much for"
870 PRINT "a team of oxen. He charges you $150 and gives you $";A-150;"change."
880 A = 150
890 INPUT "How much do you want to spend on food? $";F : F = INT(F)
900 IF F > 13 THEN GO TO 920 : ELSE PRINT "That won't even get you to the Kansas River";
910 PRINT " - better spend a bit more." : GO TO 890
920 IF A + F > 300 THEN PRINT "You won't have any for ammo and clothes." : GO TO 890
930 INPUT "How much do you want to spend on ammunition? $";B : B = INT(B)
940 IF B < 2 THEN PRINT "Better take a bit just for protection." : GO TO 930
950 IF A + F + B > 320 THEN PRINT "That won't leave any money for clothes." : GO TO 930
960 INPUT "How much do you want to spend on clothes? $";C : C = INT(C)
970 IF C > 24 THEN GO TO 990 : ELSE PRINT "Your family is going to be mighty cold in";
980 PRINT " the mountains." : PRINT "Better spend a bit more." : GO TO 960
990 IF A + F + B + C > 345 THEN PRINT "That leaves nothing for medicine." : GO TO 960
1000 INPUT "How much for medicine, bandages, repair parts, etc. $";R
1010 R = INT(R) : IF R < 5 THEN PRINT "That's not at all wise." : GO TO 1000
1020 IF A + F + B + C + R > 350 THEN PRINT "You don't have that much money." : GO TO 1000
1030 T = 350 - A - F - B - C - R : PRINT : PRINT "You now have $";T;" left." : B = 50 * B : RETurn
1040 :
1050 REMark Subroutine to initialize shooting routine
1060 PRINT\"Please rank your shooting (typing) ability as follows :"
1070 PRINT " (1) Ace marksman (2) Good shot (3) Fair to middlin' (4) Need more Practice"
1080 PRINT " (5) Shaky knees"
1090 INPUT "How do you rank yourself? ";DR
1100 IF DR > 0 AND DR < 6 THEN RETurn
1110 PRINT "Please enter 1, 2, 3, 4, or 5." : GO TO 1090
1120 :
1130 REMark Subroutine to stop at fort, hunt, or push on
1140 IF (INT(J / 2)) <> (J / 2) THEN GO TO 1190 : REMark Are we on an even trip segment?
1150 INPUT "Want to (1) stop at next fort, (2) hunt, or (3) push on? ";X
1160 IF X < 1 OR X > 3 THEN PRINT "Enter a 1, 2, or 3 please." : GO TO 1150
1170 IF X = 3 THEN RETurn : ELSE ON X GO SUB 1230, 1330
1180 IF KQ = 1 THEN GO TO 1150 : ELSE RETurn : REMark Not enough ammo to hunt?
1190 INPUT "Would you like to (1) hunt or (2) continue on ";X
1200 IF X < 1 OR X > 2 THEN PRINT "Enter a 1 or 2 please." : GO TO 1190
1210 IF X = 2 THEN RETurn : ELSE GO SUB 1330 : RETurn
1220 :
1230 REMark Subroutine to stop at a fort
1240 IF T > 0 THEN GO TO 1260 : ELSE PRINT "You sing with the folks there and get a good"
1250 PRINT "night's sleep, but you have no money to buy anything." : RETurn
1260 PRINT "What would you like to spend on each of the following;"
1270 INPUT "Food? $";P1 : INPUT "Ammunition? $";P2 : INPUT "Clothing? $";P3
1280 INPUT "Medicine and supplies? $";P4 : P = P1 + P2 + P3 + P4 : P1 = .67 * P1 : P2 = 33 * P2
1290 PRINT "The storekeeper tallies up your bill. It comes to $";P
1300 IF T >= P THEN T = T - P : F = F + P1 : B = B + P2 : C = C + .67 * P3 : R = R + .67 * P4 : RETurn
1310 PRINT "Uh, oh. That's more than you have. Better start over." : GO TO 1260
1320 :
1330 REMark Subroutine to hunt
1340 KQ = 0 : IF B > 39 THEN GO TO 1360 : REMark Enough ammo to hunt?
1350 PRINT "Tough luck. You don't have enough ammo to hunt." : KQ = 1 : RETurn
1360 M = M - 45 : GO SUB 4200 : IF BR <= 1 THEN GO TO 1400
1370 IF RND(0 TO 99) < (13 * BR) THEN GO TO 1420
1380 PRINT "Nice shot...right on target...good eatin' tonight!"
1390 F = F + 24 - 2 * BR : B = B - 10 - 3 * BR : RETurn
1400 PRINT "Right between the eyes...you got a big one!" : F = F + 26 + RND(0 TO 2)
1410 PRINT "Full bellies tonight!" : B = B - 10 - RND(0 TO 3) : RETurn
1420 PRINT "You missed completely...and your dinner got away." : RETurn
1430 :
1440 REMark Subroutine to eat
1450 IF F < 5 THEN GO TO 3140 : REMark Not enough food?
1460 INPUT "Do you want to eat (1) poorly (2) moderately or (3) well ? ";E
1470 IF E < 1 OR E > 3 THEN PRINT "Enter a 1, 2, or 3, please." : GO TO 1460
1480 F = F - 4 - 2.5 * E : IF F > 0 THEN RETurn : REMark Eating more food than you have?
1490 IF E = 1 THEN RETurn
1500 F = F + 4 + 2.5 * E : PRINT "You don't have enough to eat that well." : GO TO 1460
1510 :
1520 REMark Subroutine for riders attack
1530 IF RND(0 TO 9) > ((M / 100 - 4) ^ 2 + 72) / ((M / 100 - 4) ^ 2 + 12) - 1 THEN RETurn
1540 X$ = "" : GH = 0 : IF RND > .2 THEN X$ = "don't " : GH = 1
1550 PRINT : PRINT "Riders ahead! They ";X$;"look hostile."
1560 PRINT "You can (1) run, (2) attack, (3) ignore them, or (4) circle wagons."
1570 INPUT "What do you want to do? ";GT
1580 IF GT < 1 OR GT > 4 THEN PRINT "Please enter 1, 2, 3, or 4." : GO TO 1570
1590 IF RND < .2 THEN GH = 1 - GH : REMark Maybe they're hostile after all
1600 IF GH = 1 THEN GO TO 1810 : REMark Are they friendly?
1610 ON GT GO TO 1640, 1670, 1740, 1780
1620 :
1630 REMark Try to run away
1640 M = M + 20 : R = R - 7 : B = B - 150 : A = A - 20 : GO TO 1860 : REMark Lose stuff when you run
1650 :
1660 REMark Attack the riders
1670 GO SUB 4200 : B = B - BR * 40 - 80 : REMark Firefight uses ammo
1680 IF BR <= 1 THEN PRINT "Nice shooting ... you drove them off." : GO TO 1860
1690 IF BR <= 4 THEN PRINT "Kind of slow with your Colt .45." : GO TO 1860
1700 PRINT "Pretty slow on the draw, partner. You got a nasty flesh wound."
1710 KH = 1 : PRINT "You'll have to see the doc soon as you can." : GO TO 1860
1720 :
1730 REMark Ignore the riders
1740 IF RND > .8 THEN PRINT "They did not attack. Whew!" : RETurn
1750 B = B - 150 : R = R - 7 : GO TO 1860
1760 :
1770 REMark Circle wagons
1780 GO SUB 4200 : B = B - BR * 30 - 80 : M = M - 25 : GO TO 1680
1790 :
1800 REMark Cost of each tactic if riders were friendly
1810 IF GT = 1 THEN M = M + 15 : A = A - 5 : GO TO 1860
1820 IF GT = 2 THEN M = M - 5 : B = B - 100 : GO TO 1860
1830 IF GT = 3 THEN GO TO 1860 : ELSE M = M - 20
1840 :
1850 REMark Final messages about riders
1860 IF GH = 0 THEN GO TO 1880 : REMark Were riders hostile?
1870 PRINT "Riders were friendly, but check for possible losses." : RETurn
1880 PRINT "Riders were hostile. Better check for losses!"
1890 IF B >= 0 THEN RETurn : ELSE PRINT : GO SUB 3950 : PRINT "Oh, my gosh!";
1900 PRINT "They're coming back and you're out of ammo! Your dreams turn to"
1910 PRINT "dust as you and your family are massacred on the prairie." : GO TO 3250
1920 :
1930 REMark Subroutine to deal with hazards and special events
1940 RN = RND(0 TO 99) : REMark RN determines which event happens
1950 FOR I = 1 TO 15
1960 REMark Iterate through possible events
1970 IF RN > EP(I) THEN NEXT I : I = 16 : REMark If event happened, exit loop
1980 IF I > 8 THEN GO TO 2000
1990 ON I GO TO 2020, 2050, 2080, 2120, 2150, 2180, 2220, 2320
2000 ON I - 8 GO TO 2430, 2460, 2490, 2550, 2580, 2670, 2700, 2750
2010 :
2020 PRINT "Your wagon breaks down. It costs you time and supplies to fix it."
2030 M = M - 15 - 5 * RND : R = R - 4 : RETurn
2040 :
2050 PRINT "An ox gores your leg. That slows you down for the rest of the trip."
2060 M = M - 25 : A = A - 10 : RETurn
2070 :
2080 PRINT "Bad luck...your daughter breaks her arm. You must stop and"
2090 PRINT "make a splint and sling with some of your medical supplies."
2100 M = M - 5 - RND(0 TO 3) : R = R - 1 - 2 * RND : RETurn
2110 :
2120 PRINT "An ox wanders off and you have to spend time looking for it."
2130 M = M - 17 : RETurn
2140 :
2150 PRINT "Your son gets lost and you spend half a day searching for him."
2160 M = M - 10 : RETurn
2170 :
2180 PRINT "Nothing but contaminated and stagnant water near the trail."
2190 PRINT "You lose time looking for a clean spring or creek."
2200 M = M - 2 - RND(0 TO 9) : RETurn
2210 :
2220 IF M > 950 THEN GO TO 2270 : REMark If in mountains, go to snow; otherwise rain
2230 PRINT "Heavy rains. Traveling is slow in the mud and you break your spare"
2240 PRINT "ox yoke using it to pry your wagon out of the mud. Worse yet, some"
2250 PRINT "of your ammo is damaged by the water."
2260 M = M - 5 - RND(0 TO 9) : R = R - 7 : B = B - 400 : F = F - 5 : RETurn
2270 PRINT "Cold weather... Brrrrrrr! ... You ";
2280 IF C < 11 + RND(0 TO 1) THEN PRINT "don't "; : C1 = 1
2290 PRINT "have enough clothing to keep warm."
2300 IF C1 = 0 THEN RETurn : ELSE GO SUB 3020 : RETurn
2310 :
2320 PRINT "Bandits attacking!" : GO SUB 4200
2330 B = B - 20 * BR : IF B > 0 THEN GO TO 2360 : ELSE T = T / 3
2340 PRINT "You try to drive them off but you run out of bullets."
2350 PRINT "They grab as much cash as they can find." : GO TO 2370
2360 IF BR <= 1 THEN GO TO 2400 : REMark Good response time?
2370 PRINT "You get shot in the leg - "; : GO SUB 3950 : KH = 1
2380 PRINT "and they grab one of your oxen." : A = A - 10 : R = R - 2
2390 PRINT "Better have a doc look at your leg... and soon!" : RETurn
2400 PRINT "That was the quickest draw outside of Dodge City."
2410 PRINT "You got at least one and drove 'em off." : RETurn
2420 :
2430 PRINT "You have a fire in your wagon. Food and supplies are damaged."
2440 M = M - 15 : F = F - 20 : B = B - 400 : R = R - 2 * RND(0 TO 5) : RETurn
2450 :
2460 PRINT "You lose your way in heavy fog. Time lost regaining the trail."
2470 M = M - 10 - RND(0 TO 4) : RETurn
2480 :
2490 PRINT "You come upon a rattlesnake and before you are able to get your gun"
2500 PRINT "out, it bites you." : B = B - 10 : R = R - 2 : IF R < 0 THEN GO TO 2530
2510 PRINT "Fortunately, you acted quickly, sucked out the poison, and"
2520 PRINT "treated the wound. It is painful, but you'll survive." : RETurn
2530 PRINT "You have no medical supplies left, and you die of poison." : GO TO 3200
2540 :
2550 PRINT "Your wagon gets swamped fording a river; you lose food and clothes."
2560 M = M - 20 - RND(0 TO 19) : F = F - 15 : C = C - 10 : RETurn
2570 :
2580 PRINT "You're sound asleep and you hear a noise...get up to investigate."
2590 GO SUB 3950 : PRINT "It's wild animals! They attack you!" : GO SUB 4200
2600 IF B > 39 THEN GO TO 2620 : ELSE PRINT "You're almost out of ammo; can't reach more."
2610 PRINT "The wolves come at you biting and clawing." : KH = 1 : GO TO 3170
2620 IF BR > 2 THEN GO TO 2640
2630 PRINT "Nice shooting, pardner... They didn't get much." : RETurn
2640 PRINT "Kind of slow on the draw. The wolves got at your food and clothes."
2650 B = B - 20 * BR : C = C - 2 * BR : F = F - 4 * BR : RETurn
2660 :
2670 PRINT "You're caught in a fierce hailstorm; ammo and supplies are damaged."
2680 M = M - 5 - RND(0 TO 9) : B = B - 150 : R = R - 2 - RND(0 TO 1) : RETurn
2690 :
2700 REMark Problems from not eating well enough?
2710 IF E = 1 THEN GO SUB 3020 : RETurn : REMark If eating poorly, go to sickness routine
2720 IF E = 2 AND RND > .25 THEN GO SUB 3020 : RETurn
2730 IF E = 3 AND RND > .5 THEN GO SUB 3020 : RETurn
2740 :
2750 PRINT "Helpful Indians show you where to find more food."
2760 F = F + 7 : RETurn
2770 :
2780 REMark Subroutine to travel through mountains
2790 IF M <= 975 THEN RETurn : REMark Not in mountains yet?
2800 IF RND(0 TO 9) > 9 - ((M / 100 - 15) ^ 2 + 72) / ((M / 100 - 15) ^ 2 + 12) THEN GO TO 2890
2810 PRINT "You're in rugged mountain country." : IF RND > .1 THEN GO TO 2840
2820 PRINT "You get lost and lose valuable time trying to find the trail."
2830 M = M - 60 : GO TO 2890
2840 IF RND > .11 THEN GO TO 2870
2850 PRINT "Trail cave in damages your wagon. You lose time and supplies."
2860 M = M - 20 - RND(0 TO 29) : B = B - 200 : R = R - 3 : GO TO 2890
2870 PRINT "The going is really slow; oxen are very tired." : M = M - 45 - RND(0 TO 49)
2880 :
2890 REMark South Pass routine
2900 IF KP = 1 THEN GO TO 2930 : REMark Is the South Pass clear?
2910 KP = 1 : IF RND < .8 THEN GO TO 2980 : REMark 80% chance of blizzard
2920 PRINT "You made it safely through the South Pass....no snow!"
2930 IF M < 1700 THEN GO TO 2950
2940 IF KM = 1 THEN GO TO 2950 : REMark Through Blue Mts yet?
2950 KM = 1 : IF RND < .7 THEN GO TO 2980 : ELSE RETurn : REMark Get through without mishap?
2960 _MP = 1 : RETurn : REMark Set South Pass flag
2970 :
2980 PRINT "Blizzard in the mountain pass. Going is slow; supplies are lost."
2990 KB = 1 : M = M - 30 - RND(1 TO 39) : F = F - 12 : B = B - 200 : R = R - 5
3000 IF C < 18 + RND(0 TO 1) THEN GO TO 3020 : ELSE RETurn : REMark Enough clothes?
3010 :
3020 REMark Subroutine to deal with illness
3030 IF RND(0 TO 99) < 10 + 35 * (E - 1) THEN GO TO 3070
3040 IF RND(0 TO 99) < 100 - (40 / 4 ^ (E - 1)) THEN GO TO 3090
3050 PRINT "Serious illness in the family. You'll have to stop and see a doctor"
3060 PRINT "soon. For now, your medicine will work." : R = R - 5 : KS = 1 : GO TO 3110
3070 PRINT "Mild illness. Your own medicine will cure it."
3080 M = M - 5 : R = R - 1 : GO TO 3110
3090 PRINT "The whole family is sick. Your medicine will probably work okay."
3100 M = M - 5 : R = R - 2.5
3110 IF R > 0 THEN RETurn : ELSE PRINT " ...if only you had enough." : GO TO 3160
3120 :
3130 REMark Many ways to die on the trail
3140 PRINT "You run out of food and starve to death." : GO TO 3250
3150 T = 0 : PRINT "You need a doctor badly, but can't afford one." : GO TO 3170
3160 PRINT "You have run out of all medical supplies."
3170 PRINT : PRINT "The wilderness is unforgiving and you die of ";
3180 IF KH = 1 THEN PRINT "your injuries." : GO TO 3200
3190 PRINT "pneumonia."
3200 PRINT "Your family tries to push on, but finds the going too rough";
3210 PRINT " without you." : GO TO 3250
3220 PRINT "Your oxen are worn out and can't go another step. You try pushing"
3230 PRINT "ahead on foot, but it is snowing heavily and everyone is exhausted."
3240 PRINT : GO SUB 3950 : PRINT "You stumble and can't get up...."
3250 PRINT : GO SUB 3950 : PRINT "Some travelers find the bodies of you and your"
3260 PRINT "family the following spring. They give you a decent"
3270 PRINT "burial and notify your next of kin." : PRINT
3280 D = INT(14 * (J + ML)) : DM = INT(D / 30.5) : DD = INT(D - 30.5 * DM)
3290 PRINT "At the time of your unfortunate demise, you had been on the trail"
3300 PRINT "for ";DM;" months and ";DD;" days and had covered ";INT(M+70); " miles."
3310 PRINT "You had a few supplies left :" : GO SUB 3490 : PRINT : GO TO 3450
3320 :
3330 REMark Made it!
3340 ML = (2040 - MA) / (M - MA) : F = F + (1 - ML) * (8 + 5 * E) : Fanfare : REMark GO SUB 3830
3350 PRINT "You finally arrived at Oregon City after 2040 long miles."
3360 PRINT "You're exhausted and haggard, but you made it! A real pioneer!"
3370 D = INT(14 * (J + ML)) : DM = INT(D / 30.5) : DD = INT(D - 30.5 * DM)
3380 PRINT "You've been on the trail for ";DM;" months and ";DD;" days."
3390 PRINT "You have few supplies remaining :" : GO SUB 3490
3400 PRINT : PRINT "President James A. Polk sends you his heartiest"
3410 PRINT "congratulations and wishes you a prosperous life in your new home."
3420 GO TO 3450
3430 :
3440 REMark Play - again query
3450 PRINT : INPUT "Would you like to play again? ";A$ : GO SUB 4010
3460 IF A = 0 THEN PRINT "Okay, good luck!" : GO SUB 3950 : RUN
3470 PRINT "Okay. So long for now." : GO SUB 3950 : CLS : STOP
3480 :
3490 REMark Subroutine to print inventory
3500 INK 4
3510 PRINT , "Cash", "Food", "Ammo", "Clothes", "Medicine, parts, etc."
3520 INK 7
3530 IF F < 0 THEN F = 0 : ELSE F = INT(F)
3540 IF B < 0 THEN B = 0 : ELSE B = INT(B)
3550 IF C < 0 THEN C = 0 : ELSE C = INT(C)
3560 IF R < 0 THEN R = 0 : ELSE R = INT(R)
3570 PRINT ,T, F, B, C, R : PRINT : RETurn
3580 :
3590 REMark Subroutine to read shooting words and dates
3600 DIM S$(4,12),DA$(20,12)
3610 FOR I = 1 TO 4 : READ S$(I)
3620 DATA "POW", "BANG", "BLAM", "WHOP"
3630 :
3640 FOR I = 1 TO 20 : READ DA$(I)
3650 RETurn
3660 DATA "March 29", "April 12", "April 26", "May 10", "May 24", "June 7", "June 21"
3670 DATA "July 5", "July 19", "August 2", "August 16", "August 31", "September 13"
3680 DATA "September 27", "October 11", "October 25", "November 8", "November 22"
3690 DATA "December 6", "December 20"
3700 :
3710 REMark Subroutine to read distances and place names
3720 FOR I = 1 TO 15 : READ MP(I), PL$(I)
3730 RETurn
3740 DATA    5, "on the high prairie."
3750 DATA  200, "near Independence Crossing on the Big Blue River."
3760 DATA  350, "following the Platte River."
3770 DATA  450, "near Fort Kearney."
3780 DATA  600, "following the North Platte River."
3790 DATA  750, "within sight of Chimney Rock."
3800 DATA  850, "near Fort Laramie."
3810 DATA 1000, "close upon Independence Rock."
3820 DATA 1050, "in the Big Horn Mountains."
3830 DATA 1150, "following the Green River."
3840 DATA 1250, "not too far from Fort Hall."
3850 DATA 1400, "following the Snake River."
3860 DATA 1550, "not far from Fort Boise."
3870 DATA 1850, "in the Blue Mountains."
3880 DATA 2040, "following the Columbia River."
3890 :
3900 REMark Read probabilities of events
3910 FOR I = 1 TO 15 : READ EP(I)
3920 RETurn
3930 DATA 6, 11, 13, 15, 17, 22, 32, 35, 37, 42, 44, 54, 64, 69, 95
3940 :
3950 REMark Subroutine to create a short random pause
3960 PAUSE RND(50 TO 150)
3970 REMark Original delay code
3980 REMark FOR I = 1 TO 1000 : NEXT I
3990 RETurn
4000 :
4010 REMark Subroutine to read a yes/no answer
4020 X$ = LEFT$(A$, 1) : IF X$ = "Y" OR X$ = "y" THEN A = 0 : RETurn
4030 IF X$ = "N" OR X$ = "n" THEN A = 1 : RETurn
4040 PRINT "Don't understand your answer of " ;A$; "."
4050 INPUT "Please enter Y for 'yes' or N for 'no.' Which is it? ";A$ : GO TO 4020
4060 :
4070 DEFine PROCedure Fanfare
4080   REMark Subroutine to play a fanfare
4090   IF sound_on% = 0 THEN RETurn
4100   FQ = 220 : REMark sound frequency
4110   SOUND FQ, 3 :
4120   SOUND FQ * 1.333, 3
4130   SOUND FQ * 1.584, 3
4140   SOUND FQ * 1.885, 5
4150   SOUND FQ * 1.584, 2
4160   SOUND FQ * 1.885, 10
4170   REMark RETurn
4180 END DEFine Fanfare
4190 :
4200 REMark Subroutine to shoot gun
4210 RN = RND(1 TO 4) : REMark Pick a random shooting word
4220 S1 = DATE : REMark 60 * (MID$(TIME$, 4, 2)) + (RIGHT$(TIME$, 2)) : REMark Start timer
4230 INPUT "Type " ;(S$(RN));" ";X$
4240 IF NOT(S$(RN) == X$) THEN PRINT "Nope. Try again. "; : GO TO 4230
4250 S2 = DATE : REMark 60 * (MID$(TIME$, 4, 2)) + (RIGHT$(TIME$, 2)) : REMark End timer
4260 BR = S2 - S1 - DR - 1
4270 RETurn
4280 :
4290 REMark Conversion routines for SuperBASIC
4300 DEFine PROCedure LOCATE (X,y)
4310   AT X,y
4320 END DEFine LOCATE
4330 :
4340 DEFine FuNction LEFT$(St$,n)
4350   IF n > LEN(St$) OR n < 1 OR St$ = "" THEN
4360     RETurn ""
4370   ELSE
4380     RETurn St$(1 TO n)
4390   END IF
4400 END DEFine LEFT$
4410 :
4420 DEFine FuNction MID$(St$,n1,n2)
4430   IF n1 > LEN(St$) OR n1 < 1 OR n2 < 1 OR St$ = "" THEN RETurn ""
4440   IF (n1+n2-1) > LEN(St$) THEN RETurn St$(n1 TO LEN(St$))
4450   RETurn St$(n1 TO n1+n2-1)
4460 END DEFine MID$
4470 :
4480 DEFine FuNction RIGHT$(St$,n)
4490   IF St$ = "" OR n < 1 THEN RETurn ""
4500   IF n > LEN(St$) THEN RETurn S$
4510   RETurn St$(LEN(St$)-n+1 TO LEN(St$))
4520 END DEFine RIGHT$
4530 :
4540 DEFine PROCedure INITIALISE_DISPLAY
4550   WINDOW 512,256,ox%,oy%
4560   PAPER 0
4570   INK 7
4580   BORDER 1,0
4590   CLS
4600 END DEFine INITIALISE_DISPLAY
4610 :
4620 DEFine PROCedure SOUND(pitch,duration)
4630   LOCal wait
4640   BEEP 2000*duration,pitch/50
4650   REPeat wait : IF NOT BEEPING THEN EXIT wait
4660   PAUSE RND(1 TO 3)
4670 END DEFine SOUND
4680 :
